/*---------------------------------------------------------------------------------

	FILE:
		screen buffering.h
	
	DESCRIPTION:
		this file contains a set of data structures and routines to maintain 
		an offscreen buffer from within an application.
	
	COPYRIGHT:
		1993 Hugo M. Ayala
		1993 Apple Computer Inc.
		
	CHANGE LOG:
	
		02/20/93		Hugo		adpated to writing GraphicsLab

---------------------------------------------------------------------------------*/
#pragma once

#ifndef screenBufferingIncludes
#define screenBufferingIncludes

#ifndef __TYPES__
	#include "Types.h"
#endif
#ifndef __QUICKDRAW__
	#include "Quickdraw.h"
#endif
#ifndef graphicsTypesIncludes
	#include "graphics types.h"
#endif

typedef struct viewPortBufferRecord **viewPortBuffer;

viewPortBuffer NewViewPortWBuffer( WindowPtr window, gxViewPort view, 
	const gxColor *backcolorPtr );
void DisposeViewPortWBuffer( viewPortBuffer sb );

void UpdateViewPortWBuffer( viewPortBuffer sb, gxShape clip, gxMapping *displaymap );
void DrawShapeBuffered( viewPortBuffer sb, gxShape page, const gxRectangle *updatearea );

void SetViewPortWBufferDither( viewPortBuffer sb, const long ditherlevel );

#endif