#include <QDOffscreen.h>
#include <QuickTimeComponents.h>

#include <QD3D.h>
#include <QD3DAcceleration.h>
#include <QD3DCamera.h>
#include <QD3DController.h>
#include <QD3DDrawContext.h>
#include <QD3DErrors.h>
#include <QD3DGeometry.h>
#include <QD3DGroup.h>
#include <QD3DIO.h>
#include <QD3DLight.h>
#include <QD3DMath.h>
#include <QD3DPick.h>
#include <QD3DRenderer.h>
#include <QD3DSet.h>
#include <QD3DShader.h>
#include <QD3DStorage.h>
#include <QD3DString.h>
#include <QD3DStyle.h>
#include <QD3DTransform.h>
#include <QD3DView.h>

#define		kGestaltTrap			0xA0AD

static const AEEventClass	kDraggingClass 			= 'drag' ;
static const AEEventID		kDragDrawID				= 'draw' ;
static const AEEventID		kDragSendID				= 'send' ;
static const AEEventID		kDragReceiveID			= 'recv' ;
static const AEEventID		kDragTrackID			= 'trak' ;
static const AEEventID		kDragDragID				= 'drag' ;
static const AEKeyword		keyPrivateData			= 'priv' ;

static const RGBColor		kMyBlackColor			= {0,0,0};
static const RGBColor		kMyWhiteColor			= {65535,65535,65535};
static const TQ3ColorRGB	kMyClearColor			= {1.0,1.0,1.0};
static const TQ3ColorARGB	kMyAClearColor			= {0, 0, 0, 0};
static const Rect			kMyBoundsRect			= {42,4,282,324};
static const Rect			kMyBoundsPanoRect		= {42,4,428,260};
static const Rect			kMyBoundsBigRect		= {0,0,768,512};

static const TQ3Point3D		kMyDefaultFrom			= {0.0,0.0,1.0};
static const TQ3Point3D		kMyDefaultTo			= {0.0,0.0,0.0};
static const TQ3Vector3D	kMyDefaultUp			= {0.0,1.0,0.0};
static const float			kMyDefaultHither		= 0.01;
static const float			kMyDefaultYon			= 1000.0;

static const float			kMyDistanceFactor		= 5.0;
static const TQ3Point3D		kMyZeroPoint			= {0,0,0};

static const CodecType		kMyCodec				= 'rpza' ;
	
typedef struct _DocumentRecord {
	CWindowPtr				theWindow;									// display window
	FSSpec					theFileSpec;								// input file & ref
	short					fRefNum;
	GWorldPtr				drawContextOffscreen;						// offscreen buffer
	TQ3GroupObject			documentGroup;								// main group for the document
	TQ3ViewObject			theView;									// the documents view object
	TQ3Matrix4x4			modelRotation;								// model rotation
	TQ3InterpolationStyle	currentInterpolation;
	
	TQ3ShaderObject			illuminationShader ;
	TQ3Point3D				documentGroupCenter;						// center of the model
	float					documentGroupScale;
	
	Movie					dstMovie;	
	Track					dstTrack;	
	Media					dstMedia;	
	short					dstMovieRefNum;	
	CodecType				theCodecType;
	Handle					compressedData;
	Ptr						compressedDataPtr;
	ImageDescriptionHandle	idh;
	
} DocumentRecord, *DocumentPtr, **DocumentHandle ;


pascal OSErr	MyAEHandleOAPP(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon) ;
pascal OSErr 	MyAEHandleODOC(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon) ;
pascal OSErr 	MyAEHandlePDOC(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon) ;
pascal OSErr 	MyAEHandleQUIT(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon) ;
pascal OSErr 	MyAEHandleDragRecv(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon) ;
