/*
 *  ToolFrontEnd.h - Tool Server Front End Drop-In Preferences
 */

#ifndef _H_ToolFrontEnd
#define _H_ToolFrontEnd

#ifndef __TYPES__
#include <Types.h>
#endif

#include "DropInCompiler.h"


#pragma options align=mac68k


/* this is the name of the panel, as shown in the Finder */
#define kToolFrontEndPanelName	"\pToolFrontEnd Panel"


/*
 *	AppleScript dictionary info.  As a rule of thumb, dropin panels should use the 
 *	same terminology and numeric code in their 'aete' that the IDE uses if there 
 *	is already a similar item in the IDE's 'aete'.  That is the case here, so we 
 *	merely duplicate applicable 68K Project and 68K Linker user terms below.
 */

enum {
/*	Symbolic Name				   Code		AETE Terminology		*/
	class_Sample				= 'TSFE',

	prefsPR_ProjectType			= 'PR01',	/* Project Type			*/
	prefsPR_FileName			= 'PR02',	/* File Name			*/
	prefsLN_GenerateSymFile		= 'LN02',	/* Generate SYM File	*/
	
	/* enumeration for project type */
	enumeration_ProjectType		= 'PRPT',
	enum_Project_Application	= 'PRPA',	/* application			*/
	enum_Project_Library		= 'PRPL',	/* library				*/
	enum_Project_SharedLibrary	= 'PRPS',	/* shared library		*/
	enum_Project_CodeResource	= 'PRPC',	/* code resource		*/
	enum_Project_MPWTool		= 'PRPM'	/* MPW tool				*/
};


/* internal codes for project type */
enum { 
	kProjTypeApplication,
	kProjTypeLibrary,
	kProjTypeSharedLib,
	kProjTypeCodeResource,
	kProjTypeMPWTool
};


/*	This is the structure that is manipulated by the panel. */

typedef struct ToolFrontEndPref {
	short			version;			/* version # of prefs data	*/
	Str255			scriptIncludeFile;	// the name of the script include file
	short			numExtensions;		// number of extensions
	struct ExtensionEntry
	{
		Str15		extension;			// extension of these files
		Str31		scanner;			// scanner for include files
		Str15		includeFileArg;		// argument prefix for an include file
		Str255		commandTemplate;	// template command for ToolServer
	}				extensions[1];		// array of extensions -- variable sized
} ToolFrontEndPref, **ToolFrontEndPrefHandle;


// status structure passed around internally

#define MAXFOLDERPATHS 128 // get real....

typedef struct
{
	CompilerParameterBlock *cpb;
	long linecount;
	short numFolderPaths;
	struct
	{
		short vRefNum;
		long dirID;
		Handle path;
	} folderPaths[MAXFOLDERPATHS];
	struct ScannerStatus *scanStatus;
} ToolFrontEndStatus;


#pragma options align=reset


#endif

